// CopySpdBench.cpp : R\[ AvP[ṼGg |Cg`܂B
//
// MyDiskTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//
#include "stdafx.h"

#include <iostream>
#include <windows.h>
#include <sstream>
#include <time.h>
#include <conio.h>
#include <fstream>
#include <vector>
#include <map>
#include <algorithm>

#pragma comment(lib,"winmm.lib")

using namespace std;

BOOL DeleteDirectory( LPCTSTR lpPathName )
{
	// ͒l`FbN
	if( NULL == lpPathName )
	{
		return FALSE;
	}

	// fBNg̕ۑiI['\'ȂȂtj
	TCHAR szDirectoryPathName[_MAX_PATH];
	_tcsncpy_s( szDirectoryPathName, _MAX_PATH, lpPathName, _TRUNCATE );
	if( '\\' != szDirectoryPathName[_tcslen(szDirectoryPathName) - 1] )
	{	// ԍŌ'\'ȂȂtB
		_tcsncat_s( szDirectoryPathName, _MAX_PATH, _T("\\"), _TRUNCATE );
	}

	// fBNg̃t@Cp̃t@C쐬
	TCHAR szFindFilePathName[_MAX_PATH];
	_tcsncpy_s( szFindFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
	_tcsncat_s( szFindFilePathName, _MAX_PATH, _T("*"), _TRUNCATE );

	// fBNg̃t@CJn
	WIN32_FIND_DATA		fd;
	HANDLE hFind = FindFirstFile( szFindFilePathName, &fd );
	if( INVALID_HANDLE_VALUE == hFind )
	{	// ΏۃtH_݂ȂB
		return FALSE;
	}

	do
	{
		if( '.' != fd.cFileName[0] )
		{
			TCHAR szFoundFilePathName[_MAX_PATH];
			_tcsncpy_s( szFoundFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
			_tcsncat_s( szFoundFilePathName, _MAX_PATH, fd.cFileName, _TRUNCATE );

			if( FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes )
			{	// fBNgȂċNĂяoō폜
				if( !DeleteDirectory( szFoundFilePathName ) )
				{
					return FALSE;
				}
			}
			else
			{	// t@CȂWin32API֐pč폜
				if( !DeleteFile( szFoundFilePathName ) )
				{
					return FALSE;
				}
			}
		}
	} while( FindNextFile( hFind, &fd ) );

	FindClose( hFind );

	return RemoveDirectory( lpPathName );
}

//nFileSizeKBP
bool Init(const string& rsHeader, long long nFileSize, int nFileNum)
{
	BOOL result;
	int BufSize = 1024*1024; //MKB

	char *buf = new char[BufSize];
	char sFileNameFrom[100];

	long long nLoopNum = nFileSize/1024;
	DWORD nAmari = (DWORD)(nFileSize%1024);

	for (int j=0; j<nFileNum; ++j) {
		int temp = BufSize / 2;
		for(int i=0;i< temp;i++){
			memset((buf + i*2), rand(), 2);
		}
		sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s\\test%d.dat", rsHeader.c_str(), j);
		HANDLE hFile = ::CreateFile(sFileNameFrom, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

		if(hFile == INVALID_HANDLE_VALUE){
			cout << " CreateFile Error:INVALID_HANDLE_VALUE" << endl;
			delete [] buf;
			return false;
		}
		USHORT lpInBuffer = COMPRESSION_FORMAT_NONE;
		DWORD lpBytesReturned = 0;
		DeviceIoControl(hFile, FSCTL_SET_COMPRESSION, (LPVOID) &lpInBuffer,
					sizeof(USHORT), NULL, 0, (LPDWORD)&lpBytesReturned, NULL);
		DWORD writesize;
		for(long long i = 0;i < nLoopNum; ++i){
			result = WriteFile(hFile, buf, BufSize, &writesize, NULL);
			if(result == 0){
				cout << " WriteFile Error" << endl;
				delete[] buf;
				CloseHandle(hFile);
				return false;
			}
		}
		if ((nAmari != 0) && (WriteFile(hFile, buf, nAmari*1024, &writesize, NULL) == 0)){
			cout << " WriteFile Error" << endl;
			delete[] buf;
			CloseHandle(hFile);
			return false;
		}
		CloseHandle(hFile);
	}
	delete[] buf;
	return true;
}

DWORD CopyTest(const string& rDrive, long long nFileSize, int nFileNum) {

	char sFileNameFrom[100];
	char sFileNameTo[100];
	char sDirectoryName[100];

	cout << "Preparing...";
	sprintf_s(sDirectoryName, sizeof(sDirectoryName), "%s\\CopySpdBench%d", rDrive.c_str(), (unsigned int)time(0)); 

	if (CreateDirectory(sDirectoryName, NULL) && Init(sDirectoryName, nFileSize, nFileNum)) {
		cout << " Testing...";
		DWORD First = timeGetTime();
		for (int i=0; i<nFileNum; ++i) {
			sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s\\test%d.dat", sDirectoryName, i);	
			sprintf_s(sFileNameTo, sizeof(sFileNameTo), "%s\\copy%d.dat", sDirectoryName, i);
			if (!CopyFile(sFileNameFrom, sFileNameTo, FALSE)) {
				cout << "Copy Failed!" << endl;
				return 0;
			}
		}
		DWORD Last = timeGetTime();
		DeleteDirectory(sDirectoryName);
		cout << " Done.";
		return Last-First;
	}
	else {
		cout << "Init Failed" << endl;
		return 0;
	}
}

bool CopyBench(const string& sDrive, const string& sFileSize, int nFileNum, int nTrial, ostream &outResult) {

	//fBXN擾
	static map<string, long long>  _mAlreadyCheckedDrive;
	long long nFreeByte;
	map<string, long long>::const_iterator itDrive = _mAlreadyCheckedDrive.find(sDrive);
	if (itDrive == _mAlreadyCheckedDrive.end()) {
	
		DWORD SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters;
		if (GetDiskFreeSpace(sDrive.c_str(), &SectorsPerCluster, &BytesPerSector, &NumberOfFreeClusters, &TotalNumberOfClusters)) {
			nFreeByte = (long long)NumberOfFreeClusters*SectorsPerCluster*BytesPerSector/1024;
			long long nTotalByte = (long long)TotalNumberOfClusters*SectorsPerCluster*BytesPerSector/1024;
			cout << "Disk " << sDrive << " Capacity: Total=" << nTotalByte/1024.0/1024.0 << "[GB] Free=" << nFreeByte/1024.0/1024.0 << "[GB]" << endl;
			outResult << "Disk " << sDrive << " Capacity: Total=" << nTotalByte/1024.0/1024.0 << "[GB] Free=" << nFreeByte/1024.0/1024.0 << "[GB]" <<  "\r\n";
			_mAlreadyCheckedDrive.insert(make_pair(sDrive, nFreeByte));
		}
		else {
			cout << "Could not Get the Drive Information of " << sDrive << endl;
			return false;
		}
	}
	else {
		nFreeByte = itDrive->second;
	}

	//t@CTCYǂݎ
	long long nFileSize;
	char cType = sFileSize[sFileSize.length()-1];
	if ((cType == 'k') || (cType == 'K')) {
		nFileSize = (int)(atof(sFileSize.c_str()));
	}
	else if ((cType == 'm') || (cType == 'M')) {
		nFileSize = (int)(atof(sFileSize.c_str())*1024);
	}
	else if ((cType == 'g') || (cType == 'G')) {
		nFileSize = (int)(atof(sFileSize.c_str())*1024*1024);
	}
	else {
		cout << "Size Type Must Be \'K\' or \'M\' or \'G\'." << endl;
		return false;
	}
	if (nFileSize*nFileNum*2 > nFreeByte) {
		cout << "Error: Free Space is NOT Enough." << endl;
		return false;
	}

	//Rs[eXg
	cout << sDrive << " " << sFileSize << " " << nFileNum << "File[s] " << nTrial << "Trial[s]" << endl;
	outResult << sDrive << " " << sFileSize << " " << nFileNum << "File[s] " << nTrial << "Trial[s] : " ;
	double res;
	double resMB;
	double resTotal = 0;
	int nSucceeded = 0;
	for (int i=0; i<nTrial; ++i) {
		cout << "[Trial " << i << "] ";
		res = CopyTest(sDrive, nFileSize, nFileNum) / 1000.0;
		if (res != 0) {
			resMB = (nFileSize/1024.0*nFileNum) / res;
			cout << "  Result: "  << resMB << "[MB/s] (" << res << "[sec])" << endl; 
			resTotal += res;
			++nSucceeded;
		}
	}
	if (nSucceeded > 0) {
		double dResult = (nFileSize/1024.0*nFileNum*nSucceeded)/resTotal;
		double dResultSec = resTotal/nSucceeded;
		cout << "Average: " << dResult << "[MB/s] (" << dResultSec << "[sec])" << endl;
		outResult << "Average: " << dResult << "[MB/s] (" << dResultSec << "[sec])" << "\r\n";
		return true;
	}
	else return false;
}


string GetOSVersion() {

	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (GetVersionEx (&osvi)) {
		if (osvi.dwMajorVersion == 4) {
			if (osvi.dwMinorVersion == 0) return "Windows 95";
			else if (osvi.dwMinorVersion == 10) return "Windows 98";
			else if (osvi.dwMinorVersion == 90) return "Windows ME";
			else return "Unknown";
		}
		else if (osvi.dwMajorVersion == 5) {
			if (osvi.dwMinorVersion == 0) return "Windows 2000";
			else if (osvi.dwMinorVersion == 1) return "Windows XP";
			else return "Unknown";
		}
		else if (osvi.dwMajorVersion == 6) {
			if (osvi.dwMinorVersion == 0) return "Windows Vista";
			else return "Unknown";
		}
		else return "Unknown";
	}
	return "";
}
void main()
{
	srand((unsigned int)time(0));

//	DeleteDirectory("test");
	ostringstream oss;
	cout << "CopySpdBench Build: [" << __TIMESTAMP__ << "]" << endl;
	oss << "CopySpdBench Build: [" << __TIMESTAMP__ << "]" << "\r\n";

	string sOS = GetOSVersion();
	if (sOS == "") {
		cout << "Cound NOT Get OS Version. " << endl;
		return ;
	}
	cout << "OS: " << sOS << endl;
	oss << "OS: " << sOS << "\r\n";


	ifstream ifs("CopySpdBench.ini");
	if (ifs) {
		string line;
		while (getline(ifs, line)) {
			if ( !line.empty() && (line[0] != '#')) {
				char sFileSize[100];
				char sDrive[100];
				int nFileNum;
				int nTrial;
				int nRes = sscanf_s(line.c_str(), "%s %s %d %d\n", sDrive, sizeof(sDrive), sFileSize, sizeof(sFileSize), &nFileNum, &nTrial);
				if (nRes == 4)  {
					CopyBench(sDrive, sFileSize, nFileNum, nTrial, oss);
				}
				else {
					cout << "ini error: " << line << endl;
				}
			}
		}
	}
	else {
		cout << "CopySpdBench.ini NOT Found." << endl;
		CopyBench("C:", "4K", 5000, 5, oss);
	}
	ofstream ofs("result.txt");
	ofs << oss.str() << flush;

	cout << "Press Any Key to Finish." << endl;
	cout << "(To Copy the Result to the Clipboard, Press 'c'.)" << endl;
	if (_getch() == 'c') {
		if (OpenClipboard(NULL)) {
			HGLOBAL hText = GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE, oss.str().length()+1);
			char* pText = (char*)GlobalLock(hText);
			lstrcpy(pText, oss.str().c_str());
			GlobalUnlock(hText);
			EmptyClipboard();
			SetClipboardData(CF_TEXT, hText);
			CloseClipboard();
			GlobalFree(hText);
			cout << "The Result was Copied to the Clipboard." << endl;
		}
	}
}